import updateKeys from './updateKeys';

export default function decryptFile(dv: DataView, length: number, [key0, key1, key2]: [number, number, number]) {
  for (let i = 0; i < length; i += 1) {
    //read and decrypt byte
    let curChar = dv.getUint8(i);
    const keyPart = (key2 | 2) & 0xFFFF;
    const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
    curChar ^= decryptedByte & 0xFF;
    dv.setUint8(i, curChar);

    //update keys
    [key0, key1, key2] = updateKeys([key0, key1, key2], curChar);
  }

  //If it was decrypted, we skip the first 12 bytes (random encryption header)
  return new DataView(dv.buffer, 12, dv.byteLength - 12);
}
